/**
 * ---------------------------------------------------------------------
 *
 * GLPI - Gestionnaire Libre de Parc Informatique
 *
 * http://glpi-project.org
 *
 * @copyright 2015-2024 Teclib' and contributors.
 * @copyright 2003-2014 by the INDEPNET Development Team.
 * @licence   https://www.gnu.org/licenses/gpl-3.0.html
 *
 * ---------------------------------------------------------------------
 *
 * LICENSE
 *
 * This file is part of GLPI.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * ---------------------------------------------------------------------
 */
var glpi_html_dialog=function({title:t="",body:o="",footer:a="",modalclass:n="",dialogclass:i="",id:s="modal_"+Math.random().toString(36).substring(7),appendTo:l="body",autoShow:e=true,show:d=(()=>{}),close:r=(()=>{}),buttons:c=[],bs_focus:_=true}={}){if(c.length>0){var b="";c.forEach((t=>{var o="id"in t?t.id:"button_"+Math.random().toString(36).substring(7);var a="label"in t?t.label:__("OK");var n="class"in t?t.class:"btn-secondary";b+=`\n            <button type="button" id="${o}"\n                    class="btn ${n}" data-bs-dismiss="modal">\n               ${a}\n            </button>`;if("click"in t){$(document).on("click","#"+o,(function(o){t.click(o)}))}}));a+=b}if(a.length>0){a=`<div class="modal-footer">\n         ${a}\n      </div>`}const m=!_?'data-bs-focus="false"':"";var u=`<div class="modal fade ${n}" id="${s}" role="dialog" ${m}>\n         <div class="modal-dialog ${i}">\n            <div class="modal-content">\n               <div class="modal-header">\n                  <h4 class="modal-title">${t}</h4>\n                  <button type="button" class="btn-close" data-bs-dismiss="modal"\n                           aria-label="${__("Close")}"></button>\n               </div>\n               <div class="modal-body">${o}</div>\n               ${a}\n            </div>\n         </div>\n      </div>`;glpi_close_all_dialogs();$(l).append(u);var g=document.getElementById(s);var f=new bootstrap.Modal(g,{});if(e){f.show()}g.addEventListener("shown.bs.modal",(function(t){$("#"+s).find("input, textearea, select").first().trigger("focus");d(t)}));g.addEventListener("hidden.bs.modal",(function(t){r(t);if($("div.modal.show").length===0){$("div.modal-backdrop").remove()}$("#"+s).remove()}));return s};var glpi_ajax_dialog=function({url:t="",params:o={},method:a="post",title:n="",footer:i="",modalclass:s="",dialogclass:l="",id:e="modal_"+Math.random().toString(36).substring(7),appendTo:d="body",autoShow:r=true,done:c=(()=>{}),fail:_=(()=>{}),show:b=(()=>{}),close:m=(()=>{}),buttons:u=[],bs_focus:g=true}={}){if(t.length==0){return}glpi_close_all_dialogs();$.ajax({url:t,type:a,data:o,success:function(t){glpi_html_dialog({title:n,body:t,footer:i,id:e,appendTo:d,modalclass:s,dialogclass:l,autoShow:r,buttons:u,show:b,close:m,bs_focus:g})}}).done((function(t){c(t)})).fail((function(t,o){_(t,o)}));return e};var glpi_alert=function({title:t=_n("Information","Information",1),message:o="",id:a="modal_"+Math.random().toString(36).substring(7),ok_callback:n=(()=>{})}={}){glpi_html_dialog({title:t,body:o,id:a,buttons:[{label:__("OK"),click:function(t){n(t)}}]});return a};var glpi_confirm=function({title:t=_n("Information","Information",1),message:o="",id:a="modal_"+Math.random().toString(36).substring(7),confirm_callback:n=(()=>{}),confirm_label:i=_x("button","Confirm"),cancel_callback:s=(()=>{}),cancel_label:l=_x("button","Cancel"),close_callback:e=(()=>{})}={}){glpi_html_dialog({title:t,body:o,id:a,buttons:[{label:i,click:function(t){n(t)}},{label:l,click:function(t){s(t)}}],close:e});return a};var glpi_close_all_dialogs=function(){$(".modal.show").modal("hide").remove()};var toast_id=0;const glpi_toast=(t,o,a,n={})=>{toast_id++;n=Object.assign({delay:1e4,animated:true,animation:"animate__tada",animation_extra_classes:"animate__delay-2s animate__slow"},n);const i=n.animated?`animate__animated ${n.animation} ${n.animation_extra_classes}`:"";let s=CFG_GLPI.toast_location||"bottom-right";const l=["top-left","top-right","bottom-left","bottom-right"];if(!l.includes(s)){s="bottom-right"}const e=`<div class='toast-container ${s} p-3 messages_after_redirect'>\n      <div id='toast_js_${toast_id}' class='toast ${i}' role='alert' aria-live='assertive' aria-atomic='true'>\n         <div class='toast-header ${a}'>\n            <strong class='me-auto'>${t}</strong>\n            <button type='button' class='btn-close' data-bs-dismiss='toast' aria-label='${__("Close")}'></button>\n         </div>\n         <div class='toast-body'>\n            ${o}\n         </div>\n      </div>\n   </div>`;$("body").append(e);const d=new bootstrap.Toast(document.querySelector("#toast_js_"+toast_id),{delay:n.delay});d.show()};const glpi_toast_success=(t,o=undefined,a={})=>{glpi_toast(o||__("Success"),t,"bg-success text-white border-0",a)};const glpi_toast_info=function(t,o=undefined,a={}){glpi_toast(o||_n("Information","Informations",1),t,"bg-info text-white border-0",a)};const glpi_toast_warning=(t,o=undefined,a={})=>{glpi_toast(o||__("Warning"),t,"bg-warning text-white border-0",a)};const glpi_toast_error=(t,o=undefined,a={})=>{glpi_toast(o||_n("Error","Errors",1),t,"bg-danger text-white border-0",a)};