/**
 * ---------------------------------------------------------------------
 *
 * GLPI - Gestionnaire Libre de Parc Informatique
 *
 * http://glpi-project.org
 *
 * @copyright 2015-2024 Teclib' and contributors.
 * @copyright 2003-2014 by the INDEPNET Development Team.
 * @licence   https://www.gnu.org/licenses/gpl-3.0.html
 *
 * ---------------------------------------------------------------------
 *
 * LICENSE
 *
 * This file is part of GLPI.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * ---------------------------------------------------------------------
 */
export class TeamBadgeProvider{constructor(e,t=3){this.badges={User:{},Group:{},Supplier:{},Contact:{}};this.user_pictures_to_load=new Set([]);this.dark_theme=$("html").attr("data-glpi-theme-dark")==="1";this.team_image_size=24;this.max_team_images=t;this.display_initials=e;this.event_target=new EventTarget}getTeamBadgeHash(e){const t=e["itemtype"];const s=e["id"];const a=this.getTeamBadge(e);return btoa(t+s+a).slice(0,8)}getTeamBadge(e){const t=e["itemtype"];const s=e["id"];if(this.badges[t]!==undefined&&this.badges[t][s]!==undefined){return this.badges[t][s]}if(t==="User"){this.user_pictures_to_load.add(s);this.badges[t][s]=this.generateUserBadge(e);return this.badges[t][s]}switch(t){case"Group":this.badges[t][s]=this.generateOtherBadge(e,"fa-users");break;case"Supplier":this.badges[t][s]=this.generateOtherBadge(e,"fa-briefcase");break;case"Contact":this.badges[t][s]=this.generateOtherBadge(e,"fa-user");break;default:this.badges[t][s]=this.generateOtherBadge(e,"fa-user")}return this.badges[t][s]}fetchRequiredUserPictures(){const e=Array.from(this.user_pictures_to_load.values());if(e.length===0){return}this.user_pictures_to_load.clear();$.ajax({type:"POST",url:CFG_GLPI["root_doc"]+"/ajax/getUserPicture.php",data:{users_id:e,size:this.team_image_size}}).done((t=>{const s=[];Object.keys(e).forEach((e=>{if(t[e]!==undefined){this.badges["User"][e]="<span>"+t[e]+"</span>";s.push(e)}}));this.event_target.dispatchEvent(new CustomEvent("kanban:team_badge:changed",{detail:{User:s}}))}))}hslToHexColor(e,t,s){let a,i,r;if(t===0){a=i=r=s}else{const n=function e(t,s,a){if(a<0)a+=1;if(a>1)a-=1;if(a<1/6)return t+(s-t)*6*a;if(a<1/2)return s;if(a<2/3)return t+(s-t)*(2/3-a)*6;return t};const o=s<.5?s*(1+t):s+t-s*t;const g=2*s-o;a=n(g,o,e+1/3);i=n(g,o,e);r=n(g,o,e-1/3)}a=("0"+(a*255).toString(16)).substr(-2);i=("0"+(i*255).toString(16)).substr(-2);r=("0"+(r*255).toString(16)).substr(-2);return"#"+a+i+r}getBadgeColor(e){let t=JSON.parse(window.sessionStorage.getItem("badge_colors"));const s=e["itemtype"];const a=Math.random();const i=Math.random()*10+(this.dark_theme?25:70);let r=this.hslToHexColor(a,1,i/100);if(t!==null&&t[s]!==null&&t[s][e["id"]]){r=t[s][e["id"]]}else{if(t===null){t={User:{},Group:{},Supplier:{},Contact:{},_dark_theme:this.dark_theme}}t[s][e["id"]]=r;window.sessionStorage.setItem("badge_colors",JSON.stringify(t))}return r}getBadgeCanvas(e){const t=document.createElement("canvas");t.width=this.team_image_size;t.height=this.team_image_size;const s=t.getContext("2d");s.strokeStyle="#f1f1f1";s.fillStyle=e;s.beginPath();s.arc(this.team_image_size/2,this.team_image_size/2,this.team_image_size/2,0,2*Math.PI);s.fill();s.fillStyle=this.dark_theme?"white":"black";s.textAlign="center";s.font="bold "+this.team_image_size/2+"px sans-serif";s.textBaseline="middle";return t}generateUserBadge(e){let t="";if(e["firstname"]){t+=e["firstname"][0]}if(e["realname"]){t+=e["realname"][0]}t=t.toUpperCase();if(!this.display_initials||t.length===0){return this.generateOtherBadge(e,"fa-user")}const s=this.getBadgeCanvas(this.getBadgeColor(e));const a=s.getContext("2d");a.fillText(t,this.team_image_size/2,this.team_image_size/2);const i=s.toDataURL("image/png");const r=e["name"].replace(/"/g,"&quot;").replace(/'/g,"&#39;");return"<span><img src='"+i+"' title='"+r+"' data-bs-toggle='tooltip' data-placeholder-users-id='"+e["id"]+"'/></span>"}generateOtherBadge(e,t){const s=this.getBadgeColor(e);const a=e["name"].replace(/"/g,"&quot;").replace(/'/g,"&#39;");return`\n            <span class='fa-stack fa-lg' style='font-size: ${this.team_image_size/2}px'>\n                <i class='fas fa-circle fa-stack-2x' style="color: ${s}" title="${e["name"]}"></i>\n                <i class='fas ${t} fa-stack-1x' title="${a}" data-bs-toggle='tooltip'></i>\n            </span>\n        `}generateOverflowBadge(e){const t=this.dark_theme?40:80;const s=this.getBadgeCanvas(`hsl(255, 0%, ${t}%, 1)`);const a=s.getContext("2d");a.fillText("+"+e,this.team_image_size/2,this.team_image_size/2);const i=s.toDataURL("image/png");return"<span class='position-relative'><img src='"+i+"' title='"+__("%d other team members").replace("%d",e)+"' data-bs-toggle='tooltip'/></span>"}}