/**
 * ---------------------------------------------------------------------
 *
 * GLPI - Gestionnaire Libre de Parc Informatique
 *
 * http://glpi-project.org
 *
 * @copyright 2015-2024 Teclib' and contributors.
 * @copyright 2003-2014 by the INDEPNET Development Team.
 * @licence   https://www.gnu.org/licenses/gpl-3.0.html
 *
 * ---------------------------------------------------------------------
 *
 * LICENSE
 *
 * This file is part of GLPI.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * ---------------------------------------------------------------------
 */
const StencilEditor=function(e,n,t){let o=t;let a=[];let i=this;i.init=function(){Array.prototype.forEach.call(document.querySelectorAll(".stencil-image"),(function(e){a.push(new window.Cropper(e))}));a.forEach((function(n){const t=n.getCropperSelection();t.hidden=true;t.$reset().hidden=true;n.getCropperCanvas().disabled=true;const o=n.getCropperImage();o.$ready((function(){o.$center("cover");const t=o.getBoundingClientRect();const a=n.getCropperCanvas();$(e).find(a).css("height",t.height);o.$center()}))}));$(e).on("click",".set-zone-data",(function(e){e.preventDefault();i.editorEnable(parseInt($(this).data("zone-index")))})).on("click","#save-zone-data-"+n,(function(){i.saveZoneData()})).on("click","#reset-zone-data-"+n,(function(){i.resetZoneData()})).on("click","#cancel-zone-data-"+n,(function(){i.editorDisable()})).on("click",'button[name="add-new-zone"]',(function(){i.addNewZone()})).on("click",'button[name="remove-zone"]',(function(){i.removeZone()}));$("#clear-data-"+n).on("click",(function(e){const t=$("#clear-data-"+n);if(t.data("delete")!="1"){const n=t.text();t.data("delete","1");t.text(_x("button","Are you sure?"));setInterval((()=>{t.data("delete","0");t.text(n)}),1e4);e.preventDefault()}}));$(document).on("keyup",(function(e){if(!i.isEditorActive()){return}var n=e.keyCode?e.keyCode:e.which;const t=a.some((function(e){return e.getCropperSelection()!==undefined&&e.getCropperSelection().height>0&&e.getCropperSelection().width>0}));if(n==13&&t){i.saveZoneData();e.preventDefault()}else if(n==27){i.editorDisable();e.preventDefault()}})).on("keypress",(function(e){if(!i.isEditorActive()){return}var n=e.keyCode?e.keyCode:e.which;if(n==13){const n=a.some((function(e){return e.getCropperSelection()!==undefined&&e.getCropperSelection().height>0&&e.getCropperSelection().width>0}));if(n){i.saveZoneData();e.preventDefault()}}}))}();i.editorEnable=function(t){let i=o[t]??{side:0};$(e).find('a.defined-zone[data-bs-toggle="tooltip"]').tooltip("hide");$(e).find(".set-zone-data").removeClass("btn-warning");$(e).find(".defined-zone").remove();$(e).find(".set-zone-data[data-zone-index="+t+"]").addClass("btn-warning");$(e).find("#general-submit-"+n).addClass("d-none");$(e).find("#zone-data-"+n).removeClass("d-none");$(e).find("#zone_label-"+n).val(i["label"]??t);$(e).find("#zone_number-"+n).val(i["number"]??t).data("zone-index",t);a.forEach((function(e,n){e.getCropperSelection().$reset().hidden=false;e.getCropperCanvas().disabled=false;if(Object.keys(i).length>1&&n==i["side"]){e.getCropperImage().$setTransform(i["image"]);const n=i["selection"];e.getCropperSelection().$change(n["x"],n["y"],n["width"],n["height"])}}))};i.saveZoneData=function(){const t=a.filter((e=>e.getCropperSelection()!==undefined&&e.getCropperSelection().height>0&&e.getCropperSelection().width>0))[0];const d=t.getCropperCanvas();const r=t.getCropperSelection();const s=t.getCropperImage();const c=r.x;const l=r.y;const f=r.height;const p=r.width;const u=d.getBoundingClientRect();const g=s.getBoundingClientRect();const m=g.left-u.left;const h=g.top-u.top;const C=g.width;const b=g.height;const v=c-m;const z=l-h;const x=$(e).find("#zone_number-"+n).data("zone-index");const _=$(e).find("#zone_number-"+n).val();o[x]={selection:{x:c,y:l,height:f,width:p},image:s.$getTransform(),label:$(e).find("#zone_label-"+n).val(),number:_,side:a.indexOf(t)};o[x]["x_percent"]=v*100/C;o[x]["y_percent"]=z*100/b;o[x]["height_percent"]=f*100/b;o[x]["width_percent"]=p*100/C;i.editorDisable();$(e).find(".set-zone-data[data-zone-index="+x+"]").removeClass("btn-warning").addClass("btn-success").find("i").removeClass("ti-file-unknown").addClass("ti-check");$(e).find(".set-zone-data[data-zone-index="+x+"]").find("span").text(o[x]["label"]);i.sendDataForm()};i.sendDataForm=function(){$.ajax({type:"POST",url:CFG_GLPI.root_doc+"/ajax/stencil.php",data:{update:"",id:$(e).find("input[name=id]").val(),zones:JSON.stringify(o),_no_message:1}})};i.editorDisable=function(){a.forEach((function(e){e.getCropperSelection().$reset().hidden=true;e.getCropperCanvas().disabled=true;e.getCropperImage().$center("contain")}));$(e).find(".set-zone-data").removeClass("btn-warning");$(e).find("#general-submit-"+n).removeClass("d-none");$(e).find("#zone-data-"+n).addClass("d-none");i.redoZones()};i.isEditorActive=function(){return a.some((function(e){return e.getCropperCanvas().disabled===false}))};i.redoZones=function(){$(e).find(".defined-zone").remove();for(const[t,a]of Object.entries(o)){$(e).find(".stencil-image[data-side="+a["side"]+"]").parent().append(`\n                <a href="#zone_number_-${n}${t}"\n                class="defined-zone set-zone-data d-inline-flex align-items-center justify-content-center"\n                data-zone-index="${t}"\n                data-bs-toggle="tooltip"\n                data-bs-title="${_.escape(a["label"])}"\n                data-bs-placement="auto"\n                style="left: ${a["x_percent"]}%; top: ${a["y_percent"]}%; width: ${a["width_percent"]}%; height: ${a["height_percent"]}%;">\n                    <span class="zone-number" style="max-height: 90%;\n                        max-width: 90%;\n                        overflow: hidden;\n                        display: inline-block;\n                        vertical-align: middle;\n                        text-align: center;\n                        white-space: nowrap;\n                        font-size: 0.8em;">\n                        ${_.escape(a["label"])}\n                    </span>\n                </a>\n            `)}$(e).find('a.defined-zone[data-bs-toggle="tooltip"]').tooltip("enable")};i.addNewZone=function(){$.ajax({type:"POST",url:CFG_GLPI.root_doc+"/ajax/stencil.php",data:{"add-new-zone":"",id:$(e).find("input[name=id]").val(),_no_message:1},success:function(){$("form#stencil-editor-form-"+n+' button[name="add-new-zone"][data-bs-toggle="tooltip"]').tooltip("hide");var e=$("form#stencil-editor-form-"+n+" button.set-zone-data").length+1;var t=$("#zone-number-template");var o=$(t.html());$(o).attr("data-zone-index",e);$(o).find("span").text(e);o.insertBefore(t)}})};i.removeZone=function(){$.ajax({type:"POST",url:CFG_GLPI.root_doc+"/ajax/stencil.php",data:{"remove-zone":"",id:$(e).find("input[name=id]").val(),_no_message:1},success:function(){$("form#stencil-editor-form-"+n+' button[name="remove-zone"][data-bs-toggle="tooltip"]').tooltip("hide");$("form#stencil-editor-form-"+n+" button.set-zone-data").sort((function(e,n){return $(e).data("zone-index")-$(n).data("zone-index")})).last().remove()}})};i.resetZoneData=function(){const t=$(e).find("#zone_number-"+n).data("zone-index");$.ajax({type:"POST",url:CFG_GLPI.root_doc+"/ajax/stencil.php",data:{"reset-zone":"",id:$(e).find("input[name=id]").val(),"zone-id":t,_no_message:1},success:function(){$("form#stencil-editor-form-"+n+' button[name="reset-zone-data"][data-bs-toggle="tooltip"]').tooltip("hide");var e=$('.set-zone-data[data-zone-index="'+t+'"]');e.removeClass("btn-success").removeClass("btn-warning");e.find("span").text(t);e.find("i").removeClass("ti-check").addClass("ti-file-unknown");delete o[t];i.editorDisable();i.redoZones()}})}};