/**
 * ---------------------------------------------------------------------
 *
 * GLPI - Gestionnaire Libre de Parc Informatique
 *
 * http://glpi-project.org
 *
 * @copyright 2015-2024 Teclib' and contributors.
 * @copyright 2003-2014 by the INDEPNET Development Team.
 * @licence   https://www.gnu.org/licenses/gpl-3.0.html
 *
 * ---------------------------------------------------------------------
 *
 * LICENSE
 *
 * This file is part of GLPI.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * ---------------------------------------------------------------------
 */
class GlpiFormEditorController{#t;#e;#i;#o;constructor(t,e,i,o){this.#t=t;this.#e=e;this.#i=i;this.#o=o;if($(this.#t).prop("tagName")!="FORM"){throw new Error("Target must be a valid form")}if(this.#a(this.#i).length==0){throw new Error(`Invalid default question type: ${i}`)}this.#s();this.#n();this.#d();$(this.#t).find("[data-glpi-form-editor-dynamic-input]").each(((t,e)=>{this.#r(e)}));this.#l($(this.#t).find("[data-glpi-form-editor-sections]"));if(this.#c()===0){$(this.#t).find("[data-glpi-form-editor-form-details-name]")[0].select()}}#n(){const t=_.throttle((()=>this.#s()),100);$(window).on("resize",(()=>t()));$(this.#t).on("glpi-ajax-controller-submit-success",(()=>this.#m()));$(document).on("click",(()=>{this.#p(null);$(".simulate-focus").removeClass("simulate-focus")}));$(document).on("tinyMCEChange",((t,e)=>this.#f(e)));$(document).on("tinyMCEClick",((t,e)=>this.#h(e)));$(this.#t).on("submit",(t=>{try{this.#g()}catch(e){t.preventDefault();t.stopPropagation();glpi_toast_error(__("An unexpected error occurred"));throw e}}));const e=["click","change","input"];e.forEach((t=>{const e=`data-glpi-form-editor-on-${t}`;$(document).on(t,`${this.#t} [${e}]`,(t=>{const i=$(t.currentTarget);const o=i.attr(e);try{this.#u(o,i,t)}catch(t){glpi_toast_error(__("An unexpected error occurred"));throw t}}))}))}#m(){if(this.#e){this.#$()}}#u(t,e,i){let o=true;i.stopPropagation();switch(t){case"set-active":this.#p(e);o=false;break;case"add-question":this.#v(e.closest(`\n                        [data-glpi-form-editor-active-form],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-question]\n                    `));break;case"delete-question":this.#y(e.closest("[data-glpi-form-editor-question]"));break;case"toggle-mandatory-question":this.#b(e.closest("[data-glpi-form-editor-question]"),e.prop("checked"));break;case"compute-dynamic-input":this.#r(e[0]);break;case"change-question-type-category":this.#I(e.closest("[data-glpi-form-editor-question]"),e.val());break;case"change-question-type":this.#C(e.closest("[data-glpi-form-editor-question]"),e.val());break;case"add-section":this.#q(e.closest(`\n                        [data-glpi-form-editor-active-form],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-question]\n                    `));break;case"delete-section":this.#_(e.closest("[data-glpi-form-editor-section]"));break;case"build-move-section-modal-content":this.#k();o=false;break;case"reorder-sections":this.#S();break;case"merge-with-previous-section":this.#w(e.closest("[data-glpi-form-editor-section]"));break;case"collapse-section":this.#E(e.closest("[data-glpi-form-editor-section]"));break;case"duplicate-section":this.#T(e.closest("[data-glpi-form-editor-section]"));break;case"duplicate-question":this.#A(e.closest("[data-glpi-form-editor-question]"));break;case"question-sort-update":break;default:throw new Error(`Unknown action: ${t}`)}if(o){window.glpiUnsavedFormChanges=true}this.#d()}#g(){let t=0;const e=$(this.#t).find("[data-glpi-form-editor-section]");e.each(((e,i)=>{this.#M($(i).find("[data-glpi-form-editor-section-details]"),"section",e);this.#Q($(i),e);this.#x($(i));const o=$(i).find("[data-glpi-form-editor-question]");o.each(((e,o)=>{this.#M($(o),"question",t);this.#Q($(o),e);this.#x($(o));this.#U($(o),$(i));t++}))}))}#d(){this.#D();this.#F();this.#H();this.#R();this.#B()}#M(t,e,i){const o=t.find("input[name], select[name], textarea[name]");o.each(((t,o)=>{const a=$(o).attr("name");if(!$(o).data("glpi-form-editor-original-name")){$(o).attr("data-glpi-form-editor-original-name",a)}let s=$(o).data("glpi-form-editor-original-name");let n="";if(e==="section"){n=`_sections[${i}]`}else if(e==="question"){n=`_questions[${i}]`;const t=$(o).attr("data-glpi-form-editor-specific-question-extra-data")!==undefined;if(t){n+=`[extra_data]`}}else{throw new Error(`Unknown item type: ${e}`)}let d="";if(s.endsWith("[]")){s=s.slice(0,-2);d="[]"}$(o).attr("name",n+`[${s}]${d}`)}))}#Q(t,e){this.#P(t,"rank",e)}#x(t){const e=this.#V(t,"id");if(e==0){this.#P(t,"id",getUUID());this.#P(t,"_use_uuid",1)}}#U(t,e){const i=this.#V(e,"id");this.#P(t,"forms_sections_id",i);this.#P(t,"_use_uuid_for_sections_id",this.#V(e,"_use_uuid"))}#f(t){const e=$(t.target.container).closest("[data-glpi-form-editor-question-description]");if(e.length>0){this.#j(e,t.level.content)}}#h(t){const e=$(t.target).closest("#tinymce").data("id");const i=$(`#${e}`);this.#p(i.closest('[data-glpi-form-editor-on-click="set-active"]'))}#s(){const t=document.body.offsetHeight;const e=$(this.#t).offset().top;const i=1;let o=t-e-i;if($("#debug-toolbar").length>0){const t=$("#debug-toolbar").height();o-=t}$(this.#t).css("height",`${o}`)}#$(){const t=$("#form-form button[name=update]");t.find(".ti-plus").removeClass("ti-plus").addClass("ti-device-floppy");t.find(".add-label").text(__("Save"));t.prop("title",__("Save"));const e=$("#form-form button[name=delete]");e.removeClass("d-none");this.#e=false}#j(t,e){const i=document.createElement("div");i.innerHTML=e;const o=i.textContent||i.innerText||"";const a=o.length;if(a==0){t.attr("data-glpi-form-editor-question-extra-details","")}else{t.removeAttr("data-glpi-form-editor-question-extra-details")}}#p(t){const e=["form","section","question"];e.forEach((t=>{$(this.#t).find(`[data-glpi-form-editor-active-${t}]`).removeAttr(`data-glpi-form-editor-active-${t}`)}));if(t!==null){e.forEach((e=>{if(t.data(`glpi-form-editor-${e}-details`)!==undefined){t.closest(`[data-glpi-form-editor-${e}]`).attr(`data-glpi-form-editor-active-${e}`,"")}else if(t.data(`glpi-form-editor-${e}`)!==undefined){t.attr(`data-glpi-form-editor-active-${e}`,"")}}));const i=t.closest("[data-glpi-form-editor-section]");if(i.hasClass("section-collapsed")){return}t.addClass("active")}}#v(t){let e;let i;if(t.data("glpi-form-editor-question")!==undefined){e=t;i="after"}else if(t.data("glpi-form-editor-section")!==undefined){e=t.closest("[data-glpi-form-editor-section]").find("[data-glpi-form-editor-section-questions]");i="prepend"}else if(t.data("glpi-form-editor-form")!==undefined){e=$(this.#t).find("[data-glpi-form-editor-section]:last-child").find("[data-glpi-form-editor-section-questions]:last-child");i="append"}else{throw new Error("Unexpected target")}const o=this.#a(this.#i).children();const a=this.#z(o,e,i);this.#p(a);a.find("[data-glpi-form-editor-question-details-name]")[0].focus()}#y(t){if($(this.#t).find("[data-glpi-form-editor-question]").length==1&&$(this.#N())==1){this.#p($(this.#t).find("[data-glpi-form-editor-form-details]"))}else{if(t.prev().length>0){this.#p(t.prev())}else{this.#p(t.closest("[data-glpi-form-editor-section]"))}}t.remove()}#b(t,e){if(e){t.addClass("mandatory-question")}else{t.removeClass("mandatory-question")}}#a(t){const e=$.escapeSelector(t);return $(this.#o).find(`[data-glpi-form-editor-question-template=${e}]`)}#z(t,e,i="append"){const o=t.clone();const a=[];const s=[];o.find("textarea").each((function(){let t=$(this).attr("id");const e=_.cloneDeep(window.tinymce_editor_configs[t]);const i=getUUID();$(this).attr("id",`_tinymce_${i}`);t=$(this).attr("id");e.selector="#"+t;a.push(e);window.tinymce_editor_configs[t]=e}));o.find("select").each((function(){const t=$(this).attr("id");const e=window.select2_configs[t];if($(this).hasClass("select2-hidden-accessible")===false&&e!==undefined){s.push(e)}}));switch(i){case"append":o.appendTo(e);break;case"prepend":o.prependTo(e);break;case"before":o.insertBefore(e);break;case"after":o.insertAfter(e);break;default:throw new Error(`Unknown action: ${i}`)}a.forEach((t=>tinyMCE.init(t)));s.forEach((t=>setupAjaxDropdown(t)));const n=o.find('[data-bs-toggle="tooltip"]');[...n].map((t=>new bootstrap.Tooltip(t)));return o}#V(t,e){if(t.data("glpi-form-editor-section")!==undefined){t=t.find("[data-glpi-form-editor-section-details]")}let i=t.find(`input[name=${e}]`);if(i.length>0){return t.find(`input[name=${e}]`).val()}i=t.find(`input[data-glpi-form-editor-original-name=${e}]`);if(i.length>0){return t.find(`input[data-glpi-form-editor-original-name=${e}]`).val()}throw new Error(`Field not found: ${e}`)}#P(t,e,i){if(t.data("glpi-form-editor-section")!==undefined){t=t.find("[data-glpi-form-editor-section-details]")}let o=t.find(`input[name=${e}]`);if(o.length>0){return t.find(`input[name=${e}]`).val(i)}o=t.find(`input[data-glpi-form-editor-original-name=${e}]`);if(o.length>0){return t.find(`input[data-glpi-form-editor-original-name=${e}]`).val(i)}throw new Error(`Field not found: ${e}`)}#r(t){$(t).css("width",getRealInputWidth(t,"1.2rem"))}#I(t,e){const i=$.escapeSelector(e);const o=$(this.#o).find(`option[data-glpi-form-editor-question-type=${i}]`);const a=t.find("[data-glpi-form-editor-question-type-selector]");a.children().remove();this.#z(o,a);if(o.length<=1){a.addClass("d-none")}else{a.removeClass("d-none")}a.trigger("change")}#C(t,e){const i=t.find("[data-glpi-form-editor-question-type-specific]");i.children().remove();const o=t.find("[data-glpi-form-editor-specific-question-options]");o.children().remove();const a=this.#a(e).find("[data-glpi-form-editor-question-type-specific]").children();const s=this.#a(e).find("[data-glpi-form-editor-specific-question-options]").children();this.#z(a,i);this.#z(s,o);$(document).trigger("glpi-form-editor-question-type-changed",[t,e])}#q(t){let e;let i;let o;if(t.data("glpi-form-editor-question")!==undefined){e=t.closest("[data-glpi-form-editor-section]");i="after";o=$(t).nextAll()}else if(t.data("glpi-form-editor-section")!==undefined){e=t.closest("[data-glpi-form-editor-section]");i="after";o=$(t).closest("[data-glpi-form-editor-section]").find("[data-glpi-form-editor-question]")}else if(t.data("glpi-form-editor-form")!==undefined){e=t.closest("[data-glpi-form-editor-form]").find("[data-glpi-form-editor-section]:last-child");i="after";o=null}else{throw new Error("Unexpected target")}const a=$(this.#o).find("[data-glpi-form-editor-section-template]").children();const s=this.#z(a,e,i);if(o!==null&&o.length>0){o.detach().appendTo(s.find("[data-glpi-form-editor-section-questions]"));o.each(((t,e)=>{this.#W($(e))}))}this.#p(s.find("[data-glpi-form-editor-section-details]"));this.#l(s);s.find("[data-glpi-form-editor-section-details-name]")[0].focus()}#_(t){if(t.prev().length==0){this.#p(t.next())}else{const e=t.prev().find("[data-glpi-form-editor-question]");if(e.length>0){this.#p(e.last())}else{if(this.#N()==2){this.#p($(this.#t).find("[data-glpi-form-editor-form-details]"))}else{this.#p(t.prev())}}}t.remove()}#D(){const t=$(this.#t).find("[data-glpi-form-editor-question]").length;if(t==0){$("[data-glpi-form-editor-on-click='add-section']").addClass("d-none")}else{$("[data-glpi-form-editor-on-click='add-section']").removeClass("d-none")}}#N(){return $(this.#t).find("[data-glpi-form-editor-section]").length}#c(){return $(this.#t).find("[data-glpi-form-editor-question]").length}#R(){if(this.#N()<=1){$(this.#t).find("[data-glpi-form-editor-section-details]").addClass("d-none");$(this.#t).find("[data-glpi-form-editor-section-number-display]").addClass("d-none")}else{$(this.#t).find("[data-glpi-form-editor-section-details]").removeClass("d-none");$(this.#t).find("[data-glpi-form-editor-section-number-display]").removeClass("d-none")}}#H(){const t=$(this.#t).find("[data-glpi-form-editor-section]");t.each(((e,i)=>{const o=$(i).find("[data-glpi-form-editor-section-number-display]");o.html(__("Step %1$d of %2$d").replace("%1$d",e+1).replace("%2$d",t.length))}))}#B(){$(this.#t).find(`[data-glpi-form-editor-on-click="merge-with-previous-section"]`).removeClass("d-none");$(this.#t).find(`[data-glpi-form-editor-section]:first-child`).find(`[data-glpi-form-editor-on-click="merge-with-previous-section"]`).addClass("d-none")}#l(t){t.each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-section-questions]");sortable(i,{handle:"[data-glpi-form-editor-question-handle]",acceptFrom:"[data-glpi-form-editor-section-questions]",placeholderClass:"glpi-form-editor-drag-question-placeholder mb-3"})}));t.find("[data-glpi-form-editor-section-questions]").on("sortupdate",(t=>{this.#u("question-sort-update",null,t)}));t.find("[data-glpi-form-editor-section-questions]").on("sortstart",(()=>{$(this.#t).addClass("disable-focus")}));t.find("[data-glpi-form-editor-section-questions]").on("sortstop",(t=>{if($(t.detail.item).hasClass("sortable-dragging")){return}this.#W($(t.detail.item));$(this.#t).removeClass("disable-focus");$(".content-editable-tinymce").removeClass("simulate-focus")}))}#k(){const t=$(this.#t).find("[data-glpi-form-editor-move-section-modal-items]");t.children().remove();$(this.#t).find("[data-glpi-form-editor-section]").each(((e,i)=>{const o=this.#V($(i),"name");const a=$("[data-glpi-form-editor-move-section-modal-item-template]").clone();const s=getUUID();$(i).attr("data-glpi-form-editor-move-section-modal-uuid",s);a.find("[data-glpi-form-editor-move-section-modal-item-section-key]").attr("data-glpi-form-editor-move-section-modal-item-section-key",s);a.find("[data-glpi-form-editor-move-section-modal-item-section-name]").html(o);a.removeAttr("data-glpi-form-editor-move-section-modal-item-template");t.append(a)}));sortable($("[data-glpi-form-editor-move-section-modal-items]"),{handle:"[data-glpi-form-editor-section-handle]",placeholderClass:"glpi-form-editor-drag-section-placeholder"})}#S(){$(this.#t).find("[data-glpi-form-editor-move-section-modal]").modal("hide");$(this.#t).find("[data-glpi-form-editor-move-section-modal-items]").children().each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-move-section-modal-item-section-key]").data("glpi-form-editor-move-section-modal-item-section-key");const o=$(this.#t).find(`[data-glpi-form-editor-move-section-modal-uuid=${i}]`);o.remove().appendTo($(this.#t).find("[data-glpi-form-editor-sections]"))}));$(this.#t).find("[data-glpi-form-editor-section]").each(((t,e)=>{this.#W($(e))}))}#W(t){const e=this.#L(t);this.#X(e)}#w(t){const e=t.prev();const i=t.find("[data-glpi-form-editor-section-questions]").children();i.detach().appendTo(e.find("[data-glpi-form-editor-section-questions]"));i.each(((t,e)=>{this.#W($(e))}));t.remove()}#E(t){t.toggleClass("section-collapsed")}#T(t){const e=this.#L(t);const i=this.#z(t,t,"after");this.#X(e);this.#P(i,"id",0);i.find("[data-glpi-form-editor-question]").each(((t,e)=>{this.#P($(e),"id",0)}));this.#p(i);this.#l(i)}#A(t){const e=this.#L(t);const i=this.#z(t,t,"after");this.#X(e);this.#P(i,"id",0);this.#p(i)}#F(){$(this.#t).find("[data-glpi-form-editor-empty-div]").remove();const t=$(this.#t).find("[data-glpi-form-editor-section]");t.each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-section-questions]");if(i.children().length==0){i.append('<div data-glpi-form-editor-empty-div style="height: 1px"></div>')}}))}#L(t){const e=[];t.find("textarea").each(((t,i)=>{const o=$(i).prop("id");const a=tinymce.get(o);if(a){a.destroy();e.push(o)}}));return e}#X(t){t.forEach((t=>{tinymce.init(window.tinymce_editor_configs[t])}))}}